/*

Copyright _ 2005, Apple Computer, Inc.  All rights reserved.
NOTE:  Use of this source code is subject to the terms of the Software
License Agreement for Mac OS X, which accompanies the code.  Your use
of this source code signifies your agreement to such license terms and
conditions.  Except as expressly granted in the Software License Agreement
for Mac OS X, no other copyright, patent, or other intellectual property
license or right is granted, either expressly or by implication, by Apple.

*/

// thanks to Apple for this really cool code so I haven't had to spend hours creating it myself. I love you Apple!

/***********************************/
// AVAILABLE WEBSITES
/***********************************/
// 1- the kWebsites associated index name must match that element's array's first element
// 2- CODES to format URLS - see function formatURL
// 3- Each element[site ID, site URL (with codes - see 2){, array[name in client form, value (with codes - see 2), ...]}]

var kMenuSuffixes = new Array("month", "day", "hour");

var kWebsites = new Array(0);
kWebsites["BookingWiz"] = new Array("BookingWiz.com", "http://www.bookingwiz.com/iframe_sb_redirect.asp?fm_mic=55dcx80&fm_datecalc=0&singleMenu=car&city1=!c!&date1=!pm!/!pd!/!py!&time1=!pt!&date2=!dm!/!dd!/!dy!&time2=!dt!&Submit=GET+BEST+DEALS");

var kPickUpDate = new Date();
kPickUpDate = new Date(kPickUpDate.getTime() + (24 * 60 * 60 * 1000));
var kDropOffDate = new Date(kPickUpDate);
kDropOffDate.setDate(kDropOffDate.getDate() + 7);

// GLOBAL FUNCTION: writes a 
var kHours = ["MDNT", "1AM", "2AM", "3AM", "4AM", "5AM", "6AM", "7AM", "8AM", "9AM", "10AM", "11AM", "NOON", "1PM", "2PM", "3PM", "4PM", "5PM", "6PM", "7PM", "8PM", "9PM", "10PM", "11PM"];

/***********************************/
// SAVING AND RETRIEVING PREFERENCES
/***********************************/

// setup() is run when the body loads.  It checks to see if there is a preference for this widget
// and if so, applies the preference to the widget.

function setup() {
	widget_vcheck_textdb("http://www.widgetizer.com/update.txt", "update_link", "id\\|version", ["carForm"]);
	
	// Set-up the dates to today
	var vMenuSets = new Array("pick_up_", "drop_off_");
	var vMenu;
	var vDate = kPickUpDate;
	
	for(var i = 0; i < vMenuSets.length; i++) {
		if(i > 0) { vDate = kDropOffDate; }
		setMenuDate(vMenuSets[i], vDate);
	}
	
	adminFormGUI();
}


/*********************************/
// HIDING AND SHOWING PREFERENCES
/*********************************/

// showPrefs() is called when the preferences flipper is clicked upon.  It freezes the front of the widget,
// hides the front div, unhides the back div, and then flips the widget over.

function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToBack"); // freezes the widget so that you can change it without the user noticing
	
	front.style.display="none";		// hide the front
	back.style.display="block";		// show the back
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget over	
	
	document.getElementById('fliprollie').style.display = 'none';  // clean up the front side - hide the circle behind the info button
}


// hidePrefs() is called by the done button on the back side of the widget.  It performs the opposite transition
// as showPrefs() does.

function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget) {
		widget.prepareForTransition("ToFront");		// freezes the widget and prepares it for the flip back to the front
	}
	
	back.style.display="none";			// hide the back
	front.style.display="block";		// show the front
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget back to the front
}


// PREFERENCE BUTTON ANIMATION (- the pref flipper fade in/out)

var flipShown = false;		// a flag used to signify if the flipper is currently shown or not.


// A structure that holds information that is needed for the animation to run.
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};


// mousemove() is the event handle assigned to the onmousemove property on the front div of the widget. 
// It is triggered whenever a mouse is moved within the bounds of your widget.  It prepares the
// preference flipper fade and then calls animate() to performs the animation.

function mousemove (event)
{
	if (!flipShown)			// if the preferences flipper is not already showing...
	{
		if (animation.timer != null)			// reset the animation timer value, in case a value was left behind
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; 		// set it back one frame
		
		animation.duration = 500;												// animation time, in ms
		animation.starttime = starttime;										// specify the start time
		animation.firstElement = document.getElementById ('flip');		// specify the element to fade
		animation.timer = setInterval ("animate();", 13);						// set the animation function
		animation.from = animation.now;											// beginning opacity (not ness. 0)
		animation.to = 1.0;														// final opacity
		animate();																// begin animation
		flipShown = true;														// mark the flipper as animated
	}
}

// mouseexit() is the opposite of mousemove() in that it preps the preferences flipper
// to disappear.  It adds the appropriate values to the animation data structure and sets the animation in motion.

function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}


// animate() performs the fade animation for the preferences flipper. It uses the opacity CSS property to simulate a fade.

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
}


// these functions are utilities used by animate()

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

// these functions are called when the info button itself receives onmouseover and onmouseout events

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}


function getCarInfo () {
	var theURL = formatURL("BookingWiz"); // only one affiliate for now...
	if (window.widget) widget.openURL(theURL);
	else window.location = theURL;
}

function addMonth(pInDate, pNbMonths){
	var vOutDate= new Date(pInDate);
	vOutDate.setMonth(pInDate.getMonth() + pNbMonths);
	if (vOutDate.getDate() < pInDate.getDate()) { vOutDate.setDate(0); }
	return vOutDate;
}
function addToDate(pInDate, pMonthDelta, pDayDelta, pTimeDelta) {
	var vOutDate =  new Date(pInDate);
	if((pTimeDelta != 0) || (pMonthDelta != 0) || (pDayDelta != 0)) {
		if (pTimeDelta != 0) { vOutDate.setHours(vOutDate.getHours() + pTimeDelta); }
		if (pMonthDelta != 0) { vOutDate = addMonth(vOutDate, pMonthDelta); }
		if (pDayDelta != 0) {
			var vStartHour = vOutDate.getHours(); // if we cross the time-change date, make sure we stay at the same, absolute hour...
			vOutDate = new Date(vOutDate.getTime() + (pDayDelta * 24 * 60 * 60 * 1000));
			vOutDate.setHours(vStartHour);
		}
	}
	
	return vOutDate;
}
function dropDownChanged(elem) {
	var vPickUpMonth = window.document.carForm.pick_up_month.selectedIndex;
	var vPickUpDay = window.document.carForm.pick_up_day.value;
	var vPickUpTime = window.document.carForm.pick_up_hour.selectedIndex;
	var vDropOffMonth = window.document.carForm.drop_off_month.selectedIndex;
	var vDropOffDay = window.document.carForm.drop_off_day.value;
	var vDropOffTime = window.document.carForm.drop_off_hour.selectedIndex;
	var vDuration = kDropOffDate.getTime() - kPickUpDate.getTime();
	
	if((vPickUpMonth >= 0) && vPickUpDay && (vPickUpTime >= 0) && (vDropOffMonth >= 0) && vDropOffDay && (vDropOffTime >= 0)) {
		// ADJUST date objects
		var vToday = new Date();
		kPickUpDate = new Date(vToday.getFullYear(), vPickUpMonth, vPickUpDay, vPickUpTime, 0, 0, 0);
		if(kPickUpDate.getTime() < vToday.getTime()) kPickUpDate.setFullYear(kPickUpDate.getFullYear() + 1);
		kDropOffDate = new Date(kPickUpDate.getFullYear(), vDropOffMonth, vDropOffDay, vDropOffTime, 0, 0, 0);
		if(kDropOffDate.getTime() < kPickUpDate.getTime()) kDropOffDate.setFullYear(kDropOffDate.getFullYear() + 1);
		setMenuDate("pick_up_", kPickUpDate);
		setMenuDate("drop_off_", kDropOffDate);
		
		/*if(elem.id == "pick_up_day") {
			kPickUpDate = addToDate(kPickUpDate, 0, (vPickUpDay - kPickUpDate.getDate()), 0);
		} else if(elem.id == "pick_up_month") {
			kPickUpDate = addToDate(kPickUpDate, (vPickUpMonth - (kPickUpDate.getMonth() + 1)), 0, 0);
		} else if(elem.id == "pick_up_hour") {
			kPickUpDate = addToDate(kPickUpDate, 0, 0, (vPickUpTime - kPickUpDate.getHours() + 1));
		} else if(elem.id == "drop_off_day") {
			kDropOffDate = addToDate(kDropOffDate, 0, (vDropOffDay - kDropOffDate.getDate()), 0);
		} else if(elem.id == "drop_off_month") { 
			kDropOffDate = addToDate(kDropOffDate, (vDropOffMonth - (kDropOffDate.getMonth() + 1)), 0, 0);
		} else if(elem.id == "drop_off_hour") {
			kDropOffDate = addToDate(kDropOffDate, 0, 0, (vDropOffTime - kDropOffDate.getHours() + 1));
		}
		
		if(kPickUpDate > kDropOffDate) { // Departure AFTER arrival...
			if((elem.id == "pick_up_month") || (elem.id == "pick_up_day") || (elem.id == "pick_up_hour")) {
				kDropOffDate = new Date(kPickUpDate.getTime());
				setMenuDate("drop_off_", kDropOffDate);
			} else {
				kPickUpDate = new Date(kDropOffDate.getTime());
				setMenuDate("pick_up_", kPickUpDate);
			}
		}*/
	}
	
	if((elem.id == "pick_up_month") || (elem.id == "pick_up_day") || (elem.id == "pick_up_hour")) {
		setMenuDate("pick_up_", kPickUpDate);
	} else {
		setMenuDate("drop_off_", kDropOffDate);
	}
}

function adminFormGUI() {
	document.getElementById("carbox_submit").disabled = ((document.getElementById("city").value == null) || (document.getElementById("city").value == ""));
}

function setMenuDate(pMenuPrefix, pDate) {
	var vMenu;
	for(var j = 0; j < kMenuSuffixes.length; j++) {
		vMenu = document.getElementById(pMenuPrefix + kMenuSuffixes[j]);
		if(kMenuSuffixes[j] == "month") {
			vMenu.options[pDate.getMonth()].selected = true;
		} else if (kMenuSuffixes[j] == "day") {
			vMenu.options[pDate.getDate() - 1].selected = true;
		} else if (kMenuSuffixes[j] == "hour") {
			var vHour = pDate.getHours();
			vMenu.options[vHour].selected = true;
		}
		document.getElementById(vMenu.id+"_label").innerText = vMenu.options[vMenu.selectedIndex].text;
	}
}

function formatString(pString) {
/*
	!c! = City
	!py! = Pick-Up Year
	!pm! = Pick-Up Month
	!pd! = Pick-Up Day
	!pt! = Pick-Up Time
	!dy! = Drop-Off Year
	!dm! = Drop-Off Month
	!dd! = Drop-Off Day
	!dt! = Drop-Off Time
	!cc! = Class Code
	!rc! = Rental Company
*/
	var vResult = pString;
	vResult = vResult.replace(/\!c\!/gi, window.document.carForm.city.value);
	
	vResult = vResult.replace(/\!py\!/gi, kPickUpDate.getFullYear());
	vResult = vResult.replace(/\!pm\!/gi, window.document.carForm.pick_up_month.selectedIndex + 1);
	vResult = vResult.replace(/\!pd\!/gi, window.document.carForm.pick_up_day.value);
	vResult = vResult.replace(/\!pt\!/gi, window.document.carForm.pick_up_hour.value);
	
	vResult = vResult.replace(/\!dy\!/gi, kDropOffDate.getFullYear());
	vResult = vResult.replace(/\!dm\!/gi, window.document.carForm.drop_off_month.selectedIndex + 1);
	vResult = vResult.replace(/\!dd\!/gi, window.document.carForm.drop_off_day.value);
	vResult = vResult.replace(/\!dt\!/gi, window.document.carForm.drop_off_hour.value);
	
	if(window.widget) {
		vResult = vResult.replace(/\!cc\!/gi, widget.preferenceForKey("pref_car"));
		vResult = vResult.replace(/\!rc\!/gi, widget.preferenceForKey("pref_company"));
	} else {
		vResult = vResult.replace(/\!cc\!/gi, "ZZ");
		vResult = vResult.replace(/\!rc\!/gi, "");
	}
	return vResult;
}
function formatURL(pSiteID) {
	var vResult = kWebsites[pSiteID][1];
	if(kWebsites[pSiteID].length <= 2) { // direct call - webiste expects GET request
		vResult = formatString(vResult);
	} else { // transform to POST request through 
		var vArguments = new Array();
		for(var i = 0; i < kWebsites[pSiteID][2].length; i = i + 2) {
			vArguments[vArguments.length] = (kWebsites[pSiteID][2][i] + "=" + formatString(kWebsites[pSiteID][2][i+1]));
		}
		if(window.widget) {
			vResult = "file://" + escape(widget.system("/bin/pwd", null).outputString).replace(/\%0A/i, "") + "/get2post.html?"+formatString(vResult) + "&" + vArguments.join("&");
		} else {
			vResult = "http://www.dashboardwidgets.com/widgetbackend/makePost.htm?"+escape(vResult) + "&" + vArguments.join("&");
		}
	}
	
	return vResult;
}
