// **************** PUBLIC API ****************
function widget_vcheck_textdb(pUpdateDatabaseURL, pUpdateAvailableMessageElementID, pDBLineFormat, pPagePanels) { widget_vcheck_getDB(pUpdateDatabaseURL, widget_vcheck_receive_textdb, { target: pUpdateAvailableMessageElementID, format: pDBLineFormat, pageIDs: pPagePanels }); }


// **************** PRIVATE API ****************
function widget_vcheck_receive_textdb(pResponseText, pUserInfos) {
	if((pResponseText == null) || (pUserInfos == null)) return;
	
	try {
		var vLines = pResponseText.match(/^.*$/gm);
		var vWidgetID = getKeyValue("Info.plist", "CFBundleName");
		
		var vRegEx = new RegExp(pUserInfos.format.replace(/id/gi, vWidgetID).replace(/version/gi, "(\\d+(?:\\.\\d+)+)"), "i");
		var vDBVersion = null;
		for(var vLoop = 0; vLoop < vLines.length; vLoop++) {
			var vInfos = vLines[vLoop].match(vRegEx);
			if(vInfos != null) {
				vDBVersion = vInfos[1];
				break;
			}
		}
	} catch(vException) { return null; }
	
	widget_vcheck(vDBVersion, pUserInfos);
}
function widget_vcheck(pDBVersion, pUserInfos) {
	if((pDBVersion == null) || (pUserInfos == null)) return;
	if(pUserInfos.target == null) return;
	
	var vObject = document.getElementById(pUserInfos.target);
	if(vObject == null) return;
	
	var vWidgetVersion = getKeyValue("Info.plist", "CFBundleVersion");
	if(vWidgetVersion < pDBVersion) {
		var vCloseButton = document.getElementById("closeButton");
		if(vCloseButton != "") {
			vCloseButton.onclick = function() { widget_vcheck_dismiss(pUserInfos); }
		}
		vObject.style.display = "block";
		vObject = document.getElementById(pUserInfos.target + "_window");
		if(vObject != null) vObject.style.display = "block";
		var vPageIDs = pUserInfos.pageIDs;
		if(vPageIDs != null) {
			for(var vLoop = 0; vLoop < vPageIDs.length; vLoop++) {
				vObject = document.getElementById(vPageIDs[vLoop]);
				if(vObject != null) vObject.style.display = "none";
			}
		}
	}
}
function widget_vcheck_dismiss(pUserInfos) {
	var vObject = document.getElementById(pUserInfos.target)
	if(vObject != null) vObject.style.display = "none";
	vObject = document.getElementById(pUserInfos.target + "_window");
	if(vObject != null) vObject.style.display = "none";
	var vPageIDs = pUserInfos.pageIDs;
	if(vPageIDs != null) {
		for(var vLoop = 0; vLoop < vPageIDs.length; vLoop++) {
			vObject = document.getElementById(vPageIDs[vLoop]);
			if(vObject != null) vObject.style.display = "block";
		}
	}
	
	if(widget_vcheck_dismiss_callback) widget_vcheck_dismiss_callback();
	
	return false;
}

var gwidget_vcheck_request = null;
function widget_vcheck_getDB(pUpdateDatabaseURL, pResponseHandler, pUserInfos) {
	if(pUpdateDatabaseURL == null) return null;
	
	// get db file, return string content
	gwidget_vcheck_request = new XMLHttpRequest();
	gwidget_vcheck_request.responseHandler = pResponseHandler;
	gwidget_vcheck_request.userInfos = pUserInfos;
	gwidget_vcheck_request.onreadystatechange = widget_vcheck_db_receive;
	gwidget_vcheck_request.open("GET", pUpdateDatabaseURL,true);
	gwidget_vcheck_request.setRequestHeader("Cache-Control", "no-cache");
	gwidget_vcheck_request.send();
}
function widget_vcheck_db_receive() {
	if(gwidget_vcheck_request == null) return;
	if(gwidget_vcheck_request.readyState != 4) return;
	if(gwidget_vcheck_request.status == 200) {
		if(gwidget_vcheck_request.responseHandler != null) gwidget_vcheck_request.responseHandler(gwidget_vcheck_request.responseText, gwidget_vcheck_request.userInfos);
	} else {
		alert("widget_update_checker failed: " + gwidget_vcheck_request.statusText);
	}
}

function getKeyValue(pPList, pKey) {
	var vXML_HTTP = new XMLHttpRequest();
	vXML_HTTP.open("GET", pPList, false);
	vXML_HTTP.send(null);
	
	var vXML = vXML_HTTP.responseXML;
	var vNodeIterator = vXML.createNodeIterator(vXML.documentElement.childNodes[1], NodeFilter.SHOW_ELEMENT, null, false);
	var vResult;
	var vNode = vNodeIterator.nextNode(); // discard root
	
	while(vNode = vNodeIterator.nextNode()) {
		var vKeyName = vNode.firstChild.data;
		vNode = vNodeIterator.nextNode();
		if(vNode && (vKeyName == pKey)) return vNode.firstChild.data;
	}
	
	return null;
}
